﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Tabelle3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            panel2.Dock = DockStyle.Fill;
            Grid1.Dock = DockStyle.Fill;
            setGUI();            
        }

        private void setGUI()
        {
            Grid1.RowCount = 1;
            Grid1.ColumnCount = 5;  // einen weniger, da dynamisch addiert !!
            Grid1.Columns[0].Name = "MitarbeiterNr";
            Grid1.Columns[1].Name = "Name";
            Grid1.Columns[2].Name = "Vorname";
            Grid1.Columns[3].Name = "Abteilung";
            Grid1.Columns[4].Name = "Gehalt";

            

            int width1 = Grid1.Width - 70;  // Rand und erste Spalte
            int w = width1 / Grid1.ColumnCount;
            for (int i = 0; i < Grid1.ColumnCount; i++)
            {
                Grid1.Columns[i].Width = w;
            }


            Grid1.SelectionMode = DataGridViewSelectionMode.CellSelect;
            //Grid1.SelectionMode = DataGridViewSelectionMode.ColumnHeaderSelect;
            //Grid1.SelectionMode = DataGridViewSelectionMode.FullColumnSelect;
            Grid1.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            Grid1.SelectionMode = DataGridViewSelectionMode.RowHeaderSelect;

            Grid1.SelectionMode = DataGridViewSelectionMode.CellSelect;

            Grid1.MultiSelect = true;


            object[] row0 = { "1", "Meier", "Andreas", "Finanzen", "1203" };
            object[] row1 = { "2", "Schmidt", "Ralf", "Marketing", "5104" };
            object[] row2 = { "3", "Bender", "Hans", "CEO", "11001" };
            object[] row3 = { "4", "Opel", "Hans-Dieter", "Informatic", "3455" };
            object[] row4 = { "66", "Bischoff", "Hugo", "Forschung", "5434" };
            object[] row5 = { "77", "Ernst", "Uwe", "Controlling", "-7656" };
            object[] row6 = { "78", "Schulze", "Sabine", "Controlling", "7655" };

            Grid1.Rows.Add(row0);
            Grid1.Rows.Add(row1);
            Grid1.Rows.Add(row2);
            Grid1.Rows.Add(row3);
            Grid1.Rows.Add(row4);
            Grid1.Rows.Add(row5);
            Grid1.Rows.Add(row6);

            Grid1.ReadOnly = false;

            Grid1.AutoSize = true;

        } // setGUI


        private void Grid1_CellPainting(object sender, DataGridViewCellPaintingEventArgs e)
        {
            if (this.Grid1.Columns["Name"].Index == e.ColumnIndex && e.RowIndex >= 0)
            {
                Rectangle newRect = new Rectangle(e.CellBounds.X + 1, e.CellBounds.Y + 1, e.CellBounds.Width - 4,
                    e.CellBounds.Height - 4);

                using (
                    Brush gridBrush = new SolidBrush(this.Grid1.GridColor),
                    backColorBrush = new SolidBrush(e.CellStyle.BackColor))
                {
                    using (Pen gridLinePen = new Pen(gridBrush))
                    {
                        // Erase the cell.
                        e.Graphics.FillRectangle(backColorBrush, e.CellBounds);

                        // Draw the grid lines (only the right and bottom lines;
                        // DataGridView takes care of the others).
                        e.Graphics.DrawLine(gridLinePen, e.CellBounds.Left,
                            e.CellBounds.Bottom - 1, e.CellBounds.Right - 1,
                            e.CellBounds.Bottom - 1);
                        e.Graphics.DrawLine(gridLinePen, e.CellBounds.Right - 1,
                            e.CellBounds.Top, e.CellBounds.Right - 1,
                            e.CellBounds.Bottom);

                        // Draw the inset highlight box.
                        e.Graphics.DrawRectangle(Pens.Blue, newRect);

                        // Draw the text content of the cell, ignoring alignment.
                        if (e.Value != null)
                        {
                            e.Graphics.DrawString((String)e.Value, e.CellStyle.Font,
                                Brushes.Crimson, e.CellBounds.X + 2,
                                e.CellBounds.Y + 2, StringFormat.GenericDefault);
                        }
                        e.Handled = true;
                    }
                }
            }  // if name

            if (this.Grid1.Columns["Gehalt"].Index == e.ColumnIndex && e.RowIndex >= 0)
            {
                Rectangle newRect = new Rectangle(e.CellBounds.X + 1, e.CellBounds.Y + 1, 
                                   e.CellBounds.Width - 4,e.CellBounds.Height - 4);

                using (
                    Brush gridBrush = new SolidBrush(Color.White),
                    backColorBrush1 = new SolidBrush(Color.Red)) 
                {
                    using (Pen gridLinePen = new Pen(gridBrush))
                    {
                        // Erase the cell.
                        Brush backColorBrush;
                        Brush foreColorBrush;                        
                        if (e.Value != null)
                        {
                            string sStr = (String)e.Value;
                            if (IsNumeric(sStr))
                            {
                                int iValue = Convert.ToInt32(sStr);
                                //farbe = new Brush(
                                if (iValue > 0)
                                {
                                    foreColorBrush = Brushes.Green;
                                    backColorBrush = new SolidBrush(Color.FromArgb(0xFF, 0xEE, 0xFF));
                                }
                                else
                                {
                                    foreColorBrush = Brushes.Black;
                                    backColorBrush = new SolidBrush(Color.FromArgb(0xFF, 0x96, 0xFF));
                                }
                            }
                            else
                            {
                                foreColorBrush = Brushes.Blue;
                                backColorBrush = new SolidBrush(Color.FromArgb(0xFF, 0x96, 0x96));
                            }                        
                        }
                        else
                        {
                            foreColorBrush = Brushes.White;
                            backColorBrush = new SolidBrush(Color.FromArgb(0xFF, 0x96, 0x96));
                        }
                        e.Graphics.FillRectangle(backColorBrush, e.CellBounds);

                        // Draw the grid lines (only the right and bottom lines;
                        // DataGridView takes care of the others).
                        e.Graphics.DrawLine(gridLinePen, e.CellBounds.Left,
                            e.CellBounds.Bottom - 1, e.CellBounds.Right - 1,
                            e.CellBounds.Bottom - 1);
                        e.Graphics.DrawLine(gridLinePen, e.CellBounds.Right - 1,
                            e.CellBounds.Top, e.CellBounds.Right - 1,
                            e.CellBounds.Bottom);

                        // Draw the inset highlight box.
                        e.Graphics.DrawRectangle(Pens.Blue, newRect);

                        // Draw the text content of the cell, ignoring alignment.
                        e.Graphics.DrawString((String)e.Value, e.CellStyle.Font,
                                foreColorBrush, e.CellBounds.X + 2,
                                e.CellBounds.Y + 2, StringFormat.GenericDefault);
                        
                        e.Handled = true;
                    }
                }
            }  // if name

        }  // cellPainting


        bool IsNumeric(string sStr)
        {
            int erg;
            bool isNumber;
            isNumber = Int32.TryParse(Convert.ToString(sStr),
                System.Globalization.NumberStyles.Any,
                System.Globalization.NumberFormatInfo.InvariantInfo,
                out erg);
            return isNumber;

        }

    }  // class
}

/*
 allo,

für diese Aufgabe muss ein eigener DataGridTableStyle der TableStyles-Kollektion des DataGrid hinzugefügt werden, 
 * wobei ein eigener Nachfolger der DataGridTextBoxColumn-Klasse die visuelle Textdarstellung übernimmt. 
 * Über die Suche nach den Begriffen DataGridTableStyle und DataGridTextBoxColumn lassen sich hier im FORUM einige Beispiele finden
*/

/*
 
 Unterschiede DataGrid  vs. DataGridView
 * http://msdn.microsoft.com/en-us/library/ms171628.aspx

 
 http://msdn.microsoft.com/en-us/library/ms171618.aspx

 Cellfarbe
 * http://msdn.microsoft.com/en-us/library/hta8z9sz.aspx
 * 
 * 
 */
